package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListFirewallPoliciesLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListFirewallPoliciesLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListFirewallPoliciesLogic {
	return &ListFirewallPoliciesLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListFirewallPoliciesLogic) ListFirewallPolicies(req *types.ListFirewallPoliciesReq) (resp *types.ListFirewallPoliciesResp, err error) {
	// todo: add your logic here and delete this line
	ListFirewallPoliciesReq := &openstack.ListFirewallPoliciesReq{}
	err = copier.CopyWithOption(ListFirewallPoliciesReq, req, copier.Option{Converters: utils.Converters})
	ListFirewallPoliciesResp, err := l.svcCtx.OpenstackRpc.ListFirewallPolicies(l.ctx, ListFirewallPoliciesReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ListFirewallPoliciesResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ListFirewallPoliciesResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
